/*
  * #%L
  * Quadrige2 Core
  * %%
  * Copyright (C) 2017 Ifremer
  * %%
  * This program is free software: you can redistribute it and/or modify
  * it under the terms of the GNU Affero General Public License as published by
  * the Free Software Foundation, either version 3 of the License, or
  * (at your option) any later version.
  *
  * This program is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  * GNU General Public License for more details.
  *
  * You should have received a copy of the GNU Affero General Public License
  * along with this program.  If not, see <http://www.gnu.org/licenses/>.
  * #L%
  */
//
// Attention: Generated code! Do not modify by hand!
// Generated by: TypeSafeEnumeration.vsl in andromda-java-cartridge.
// Model Class:  Données::fr.ifremer.quadrige2.core::dao::system::rule::RuleControlEntity
// Metafacade:   org.andromda.metafacades.uml.Enumeration
// Stereotype:  Enumeration
//
package fr.ifremer.quadrige2.core.dao.system.rule;

import fr.ifremer.quadrige2.core.dao.technical.Quadrige2EnumerationDef;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.Collections;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import static org.nuiton.i18n.I18n.n;

/**
 * 
 */
public enum RuleControlEntity
    implements Serializable, Quadrige2EnumerationDef<String>
{
    SURVEY (
			"quadrige2.enumeration.RuleControlEntity.SURVEY",
			n("quadrige2.enumeration.RuleControlEntity.SURVEY.description"),
			"Observation"),
    SAMPLING_OPERATION (
			"quadrige2.enumeration.RuleControlEntity.SAMPLING_OPERATION",
			n("quadrige2.enumeration.RuleControlEntity.SAMPLING_OPERATION.description"),
			"Replicat"),
    MEASUREMENT (
			"quadrige2.enumeration.RuleControlEntity.MEASUREMENT",
			n("quadrige2.enumeration.RuleControlEntity.MEASUREMENT.description"),
			"Mesures");

    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = -9047513944157345006L;

    private String key;
    private String description;
    private String enumValue;

    /**
     * The constructor with enumeration literal value allowing
     * super classes to access it.
     */
    private RuleControlEntity(String key, String description, String value)
    {
    	this.key = key;
    	this.description = description;
        this.enumValue = value;
    }
    
    @Override
     /**
      * Setter for value. Use to override value, from configuration
      */
     public void setValue(String newValue) {
		if (newValue != null && !this.enumValue.equals(newValue)) {
			// Update static lists
	    	values.remove(this.enumValue);
	    	literals.remove(this.enumValue);
	    	this.enumValue = newValue;
	    	values.put(this.enumValue, this);
	    	literals.add(this.enumValue);
		}
    }
    

    @Override
    public String getValueAsString()
    {
        return String.valueOf(this.enumValue);
    }

    /**
     * Retrieves an instance of RuleControlEntity from <code>its name</code>.
     *
     * @param name the name to create the RuleControlEntity from.
     * @return The enumeration literal named after the 'name' argument
     */
    public static RuleControlEntity fromString(String name)
    {
        return RuleControlEntity.valueOf(name);
    }

    /**
     * Returns an enumeration literal String <code>value</code>.
     * Required by JAXB2 enumeration implementation
     *
     * @return String with corresponding value
     */
    public String value()
    {
        return this.enumValue;
    }

    /**
     * Returns an instance of RuleControlEntity from String <code>value</code>.
     * Required by JAXB2 enumeration implementation
     *
     * @param value the value to create the RuleControlEntity from.
     * @return static Enumeration with corresponding value
     */
    public static RuleControlEntity fromValue(String value)
    {
        for (RuleControlEntity enumName: RuleControlEntity.values())
        {
            if (enumName.getValue().equals(value))
            {
                return enumName;
            }
        }
        throw new IllegalArgumentException("RuleControlEntity.fromValue(" + value + ')');
    }

    /**
     * Gets the underlying value of this type safe enumeration.
     * This method is necessary to comply with DaoBase implementation.
     * @return The name of this literal.
     */
    public String getValue()
    {
        return this.enumValue;
    }
    
    @Override
    public String getDescription() {
    	return description;
    }
    
    @Override
    public String getKey() {
    	return key;
    }
    
    @Override
    public Class<?> getType() {
    	return String.class;
    }
    
    /**
     * Returns an unmodifiable list containing the literals that are known by this enumeration.
     *
     * @return A List containing the actual literals defined by this enumeration, this list
     *         can not be modified.
     */
    public static List<String> literals()
    {
        return RuleControlEntity.literals;
    }

    /**
     * Returns an unmodifiable list containing the names of the literals that are known
     * by this enumeration.
     *
     * @return A List containing the actual names of the literals defined by this
     *         enumeration, this list can not be modified.
     */
    public static List<String> names()
    {
        return RuleControlEntity.names;
    }

    private static Map<String, RuleControlEntity> values = new LinkedHashMap<String, RuleControlEntity>(3, 1);
    private static List<String> literals = new ArrayList<String>(3);
    private static List<String> names = new ArrayList<String>(3);
    private static List<RuleControlEntity> valueList = new ArrayList<RuleControlEntity>(3);

    /**
     * Initializes the values.
     */
    static
    {
        synchronized (RuleControlEntity.values)
        {
            RuleControlEntity.values.put(SURVEY.enumValue, SURVEY);
            RuleControlEntity.values.put(SAMPLING_OPERATION.enumValue, SAMPLING_OPERATION);
            RuleControlEntity.values.put(MEASUREMENT.enumValue, MEASUREMENT);
        }
        synchronized (RuleControlEntity.valueList)
        {
            RuleControlEntity.valueList.add(SURVEY);
            RuleControlEntity.valueList.add(SAMPLING_OPERATION);
            RuleControlEntity.valueList.add(MEASUREMENT);
            // For Quadrige2, lists could be reload from configuration (see method 'setValue')
            //RuleControlEntity.valueList = Collections.unmodifiableList(valueList);
        }
        synchronized (RuleControlEntity.literals)
        {
            RuleControlEntity.literals.add(SURVEY.enumValue);
            RuleControlEntity.literals.add(SAMPLING_OPERATION.enumValue);
            RuleControlEntity.literals.add(MEASUREMENT.enumValue);
            // For Quadrige2, lists could be reload from configuration (see method 'setValue')
            //RuleControlEntity.literals = Collections.unmodifiableList(literals);
        }
        synchronized (RuleControlEntity.names)
        {
            RuleControlEntity.names.add("SURVEY");
            RuleControlEntity.names.add("SAMPLING_OPERATION");
            RuleControlEntity.names.add("MEASUREMENT");
            RuleControlEntity.names = Collections.unmodifiableList(names);
        }
    }
    // type-safe-enumeration-object java merge-point
}